;-- http://radiohlam.ru -  ,   
;------------------------------------------------------------------
 list    p = 12f629
 __config 01FC4h          ;  01111 11 1 0 0 0 100 - (7,8)  , (6)   ,
                          ;  (5)GP3/-MCLR   -GP3, (4)PWRT , (3)  - , (2-0) - 
;*********  ************************************
         CBLOCK 0x20  ;     
         Flags        ;  (0  - , 1  -   , 2  -   ), 
         Counter      ;      ; 3-  Trial NEC, 4-  - Extended NEC
         ADDRESS_LOW  ;   
         ADDRESS_HIGH ;   
         COMMAND      ; 
         INV_COMMAND  ;  
         ;  33 ,     ; :26, 27-2Eh, 2Fh-36h, 37h-3eh, 3fh-46h
         ENDC             ;
;********  ***************************************
Status     equ         03h         ;   .
GPIO       equ         05h         ;    . ( 0)
Cmcon      equ         19h         ;  Cmcon -  ( 0)
TrisIO     equ         05h         ;      . ( 1)
INTCON     equ         0Bh         ;  (1)/(0)  ( )
IOCB       equ         16h         ;       ( 1)
OPT_REG    equ         01h         ;   ( 1)
TMR0       equ         01h         ;   ( 0)
OSCCAL     equ         10h         ;     ( 1)
INDF       equ         0h          ;   
FSR        equ         04h         ;     
AL         equ         0x00
AH         equ         0xFF
COM        equ         0x0D 
COM2	   equ		   0x44
;********************************************************
;    GP3 -  , GP4 -   
;********************************************************

          org 0
;******************************************************************************************
;********   ********************************************************
;***  ,      , **********
;***    , OSCCAL    03FFh (   OSCCAL - 3458)**
;******   *****************************************************************
start       bsf         Status,5         ;
            Call        3FFh             ;     w
            movwf       OSCCAL           ;
            goto        main
;********   *********************************************************
         org 4
         movf     GPIO,0
         btfss    INTCON,0               ;   0  -        
         goto     errors
     ;----    --------
         btfsc    GPIO,3         ;      -  
         goto     exit
     ;    
      ;-----    ----
         btfss Flags,0            ;    0,     
         goto new_rec
      ;-----   ------
         movf  TMR0,0             ;  
         movwf INDF
       ;-----   -----
         clrf     TMR0
       ;------------------------------
         incf  FSR,1              ;  
         movlw 47h                ;   
         xorwf FSR,0
         btfss Status,2           ;  =47 -   (  )
         goto  exit

      ;----   ---------
         bcf Flags,0
         bsf Flags,1              ;     
         clrf INTCON
;		 goto exit
         return
      ;----   --------------
new_rec  bsf Flags,0
         movlw    26h
         movwf    FSR              ;    
       ;-----   -----
         clrf     TMR0
       ;------------------------------
         bsf INTCON,5              ;    
         bcf INTCON,2
exit     bcf INTCON,0              ;     
         retfie 
;**********   **************************************************
;********     ******************************
main        bcf         Status,5         ;    0
            clrf        GPIO             ;   (   )
            movlw       .7               ;  0..2 
            movwf       Cmcon            ;  , GP0, GP1, GP2 -  /
            bsf         Status,5         ;   1-  (  1 5-   Status)
            movlw       b'00000101'      ;   1:64, 64*256=16,384 
            movwf       OPT_REG
            movlw       b'00001000'      ;   (GP3 - )
            movwf       TrisIO           ;
;******   **************************************************************
            bsf         IOCB,3           ;     GP3
            bcf         Status,5         ;    0
            bsf         INTCON,3         ;     GPIO
;------------------------------------------------------------------------------------------
            bcf         GPIO,4           ;  
    ;        bsf         GPIO,2           ; 
;******   **************************************************************
            bsf         INTCON,7         ;   
			clrf   		Flags
;******   *********************************************************************
work        btfsc   Flags,1              ;     -   
            call    Convert
;            btfsc   Flags,2              ;     -   
;            call    action
            
			goto    work
;******************************************************************************************
;******************************************************************************************
;******************************************************************************************
Convert 
			bcf         INTCON,7   
			movlw   26h
            movwf   FSR                  ;    ,      
            movf    INDF,0
            addlw   .53                  ; 47 -  ( 209)+1,    209 (13,5=211  TMR0)
            andlw   b'11110000'          ;         ,
                                         ;       209<X<209+3
            btfss   Status,2             ;   Z?
            goto    errors                ;     ,     
;----------------------------------
next1       bcf     Status,0             ;    (   )
            rrf     ADDRESS_LOW,1
            incf    FSR,1
            movf    INDF,0
            addlw   .230                 ; 223 -  ( 33)+1,    33 (2,25=35  TMR0)
            andlw   b'11110000'          ;         ,
                                         ;       33<X<33+3
            btfss   Status,2             ;   Z?
            goto    Nol1                 ;      "1",    "0"
         ;------------------------
            bsf     ADDRESS_LOW,7        ;  "1"    ADDRESS_LOW
            goto    One1
Nol1        movf    INDF,0
            addlw   .247                 ; 238 -  ( 18)+1,    18 (1,12=18  TMR0)
            andlw   b'11110000'          ;         ,
                                         ;       16<X<16+3
            btfss   Status,2             ;   Z?
            goto    errors                ;      "0",  
         ;------------------------
One1        movf    FSR,0
            sublw   2eh                  ;    8  -  
            btfss   Status,2             ;   Z?
            goto    next1                ;    8  - 
;----------------------------------
next2       bcf     Status,0             ;    (   )
            rrf     ADDRESS_HIGH,1
            incf    FSR,1
            movf    INDF,0
            addlw   .230                 ; 223 -  ( 33)+1,    33 (2,25=35  TMR0)
            andlw   b'11110000'          ;         ,
                                         ;       33<X<33+3
            btfss   Status,2             ;   Z?
            goto    Nol2                 ;      "1",    "0"
         ;------------------------
            bsf     ADDRESS_HIGH,7       ;  "1"    ADDRESS_HIGH
            goto    One2
Nol2        movf    INDF,0
            addlw   .247                 ; 238 -  ( 18)+1,    18 (1,12=18  TMR0)
            andlw   b'11110000'          ;         ,
                                         ;       16<X<16+3
            btfss   Status,2             ;   Z?
            goto    errors                ;      "0",  
         ;------------------------
One2        movf    FSR,0
            sublw   36h                  ;    8  -  
            btfss   Status,2             ;   Z?
            goto    next2                ;    8  - 
;----------------------------------
next3       bcf     Status,0             ;    (   )
            rrf     COMMAND,1
            incf    FSR,1
            movf    INDF,0
            addlw   .230                 ; 223 -  ( 33)+1,    33 (2,25=35  TMR0)
            andlw   b'11110000'          ;         ,
                                         ;       33<X<33+3
            btfss   Status,2             ;   Z?
            goto    Nol3                 ;      "1",    "0"
         ;------------------------
            bsf     COMMAND,7            ;  "1"    COMMAND
            goto    One3
Nol3        movf    INDF,0
            addlw   .247                 ; 240 -  ( 16)+1,    16 (1,12=18  TMR0)
            andlw   b'11110000'          ;         ,
                                         ;       16<X<16+3
            btfss   Status,2             ;   Z?
            goto    errors                ;      "0",  
         ;------------------------
One3        movf    FSR,0
            sublw   3eh                  ;    8  -  
            btfss   Status,2             ;   Z?
            goto    next3                ;    8  - 
;----------------------------------
next4       bcf     Status,0             ;    (   )
            rrf     INV_COMMAND,1
            incf    FSR,1
            movf    INDF,0
            addlw   .230                 ; 223 -  ( 33)+1,    33 (2,25=35  TMR0)
            andlw   b'11110000'          ;         ,
                                         ;       33<X<33+3
            btfss   Status,2             ;   Z?
            goto    Nol4                 ;      "1",    "0"
         ;------------------------
            bsf     INV_COMMAND,7        ;  "1"    INV_COMMAND
            goto    One4
Nol4        movf    INDF,0
            addlw   .247                 ; 238 -  ( 18)+1,    18 (1,12=18  TMR0)
            andlw   b'11110000'          ;         ,
                                         ;       16<X<16+3
            btfss   Status,2             ;   Z?
            goto    errors                ;      "0",  
         ;------------------------
One4        movf    FSR,0
            sublw   46h                  ;    8  -  
            btfss   Status,2             ;   Z?
            goto    next4                ;    8  - 
;-------------------------------------------
            bcf Flags,1
 ;           bsf Flags,2
;            return
;******************************************************************************************
action      comf   INV_COMMAND,0        ;      INV_COMMAND
            xorwf  COMMAND,0            ; 
            btfss  Status,2             ;   Z?
            goto   errors               ;       ,  
       ;--------------------------------------------
;            comf   ADDRESS_LOW,0        ;      INV_COMMAND
;            xorwf  ADDRESS_HIGH,0       ; 
;            btfss  Status,2             ;   Z?
;            goto   ext_nec              ;   ,   Extended NEC
       ;--------------------------------------------
;            bsf    Flags,3              ;   -  3-  (Trial NEC)
;            goto   next_trial
;ext_nec     bsf    Flags,4              ;    -  4-  (Extended NEC)
next_trial  movf   ADDRESS_LOW,0        ;  
            xorlw  AL
            btfss  Status,2             ;   Z?
            goto   errors                ;    ,  
            movf   ADDRESS_HIGH,0       ;  
            xorlw  AH
            btfss  Status,2             ;   Z?
            goto   errors                ;    ,  
            movf   COMMAND,0            ;  
            xorlw  COM
            btfsc  Status,2             ;   Z?
            bcf    GPIO,4
            movf   COMMAND,0            ;  
            xorlw  COM2
            btfsc  Status,2             ;   Z?
            bsf    GPIO,4		

       ;--------------------------
errors      movf   GPIO,0 
			clrf   Flags
            clrf   INTCON
            bsf    INTCON,3      ;     GPIO
            bsf    INTCON,7      ;   
            return

;******************************************************************************************
 end
